unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, ExtCtrls, jpeg, Menus, Grids;

type
  TForm1 = class(TForm)
    OpenDialog1: TOpenDialog;
    MainMenu1: TMainMenu;
    Main1: TMenuItem;
    Exit1: TMenuItem;
    Tools1: TMenuItem;
    AlphaBlend1: TMenuItem;
    FadeIn1: TMenuItem;
    FadeOut1: TMenuItem;
    Panel1: TPanel;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    CheckBox3: TCheckBox;
    Invert1: TMenuItem;
    RGBGBR1: TMenuItem;
    RGBBRG1: TMenuItem;
    RGBRBG1: TMenuItem;
    RGBGRB1: TMenuItem;
    RBGBGR1: TMenuItem;
    BrightnessContrast1: TMenuItem;
    TP1: TMenuItem;
    Grayscale1: TMenuItem;
    TP2: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure LoadFirstselfClick(Sender: TObject);
    procedure LoadSecondselfClick(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure AlphaBlend1Click(Sender: TObject);
    procedure FadeIn1Click(Sender: TObject);
    procedure FadeOut1Click(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure Invert1Click(Sender: TObject);
    procedure RGBGBR1Click(Sender: TObject);
    procedure RGBBRG1Click(Sender: TObject);
    procedure RGBRBG1Click(Sender: TObject);
    procedure RGBGRB1Click(Sender: TObject);
    procedure RBGBGR1Click(Sender: TObject);
    procedure BrightnessContrast1Click(Sender: TObject);
    procedure TP1Click(Sender: TObject);
    procedure Grayscale1Click(Sender: TObject);
    procedure TP2Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    b,a: Tbitmap;
    procedure fade(what: string;img: Tbitmap; control: Tcontrol;no_of_frames: integer=50);
    procedure alpahblend(src: Tbitmap; dest: Tbitmap; control: Tcontrol; no_of_frames: integer=50);
    function  loadImage(img : Tbitmap): boolean;
    procedure filterImage(img: Tbitmap; red, green, blue : boolean; control: Tcontrol);
    procedure invert(img: TBitmap; control:Tcontrol);
    procedure rgbimage(img: TBitmap; convert: string ;control:Tcontrol);
    procedure bright_contrast(img: TBitmap; value: integer ;control:Tcontrol);
    procedure dither(img: TBitmap; control: Tcontrol);
    procedure grayscale(img: TBitmap; control: Tcontrol);
    procedure tp(img: Tbitmap; control: Tcontrol);
  end;

var
  Form1: TForm1;

implementation

uses slider;

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
begin
        b:= Tbitmap.create;
        a:= Tbitmap.create;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
        b.free;
        a.free;
end;

procedure TForm1.fade(what:string;img: Tbitmap; control: Tcontrol; no_of_frames: integer=50);
var
        datapointer, d: Pbyte;
        i,j,k,l, increment: cardinal;
        temp : Tbitmap;
        g: TcontrolCanvas;
begin
        g := Tcontrolcanvas.Create;

        temp := Tbitmap.create;
        temp.assign(img);

        if what = 'in' then
        begin
                for i:= 0 to img.Height-1 do
                begin
                        d  := temp.ScanLine[i];
                        for j:=0 to img.width-1 do
                        begin
                                d^ := 255;
                                inc(d);
                                d^ := 255;
                                inc(d);
                                d^ := 255;
                                inc(d);
                        end;
                end;
        end;

        increment := 255 div no_of_frames;
{        if (255 mod no_of_frames) > 0 then
                increment := increment + 1;}
                

        for k:=0 to no_of_frames do
        begin
                for i:= 0 to img.Height-1 do
                begin
                        datapointer  := img.ScanLine[i];
                        d  := temp.ScanLine[i];
                        for j:=0 to img.width-1 do
                        begin
                                for l := 1 to 3 do
                                begin
                                        if what = 'in' then
                                        begin
                                                if d^ > (datapointer^) then
                                                        d^ := d^ - increment
                                                else
                                                        d^ := datapointer^;
                                        end
                                        else
                                        begin
                                                if d^ < (255 - increment) then
                                                        d^ := d^ + increment
                                                else
                                                        d^ := 255;
                                        end;
                                        inc(d);
                                        inc(datapointer);
                                end;
                        end;
                end;
                g.control := control;
                bitblt(g.handle,0,0,temp.width,temp.height,temp.canvas.handle,0,0,SRCCOPY);
                invalidaterect(g.handle,nil,false);
                redrawwindow(g.handle,nil,0,RDW_UPDATENOW);
        end;
        temp.free;
end;


procedure TForm1.alpahblend(src, dest: Tbitmap; control: Tcontrol; no_of_frames: integer);
var
        temp : Tbitmap;
        i,j,k,l,increment: integer;
        datapointer,d: Pbyte;
        g: Tcontrolcanvas;
begin
        g := tcontrolcanvas.create;
        temp := Tbitmap.create;
        temp.assign(src);
        increment := 255 div no_of_frames;
        if (255 mod no_of_frames) > 0 then
                increment := increment + 1;

        for k:=0 to no_of_frames do
        begin
                for i:= 0 to temp.Height-1 do
                begin
                        datapointer  := dest.ScanLine[i];
                        d  := temp.ScanLine[i];
                        for j:=0 to temp.width-1 do
                        begin
                                for l := 1 to 3 do
                                begin
                                        if d^ < (datapointer^ - increment) then
                                                d^ := d^ + increment
                                        else
                                        if d^ > (datapointer^ + increment) then
                                                d^ := d^ - increment
                                        else
                                                d^ := datapointer^;
                                        inc(d);
                                        inc(datapointer);
                                end;
                        end
                end;
                g.control := control;
                bitblt(g.handle,0,0,temp.width,temp.height,temp.canvas.handle,0,0,SRCCOPY);
                invalidaterect(g.handle,nil,false);
                redrawwindow(g.handle,nil,0,RDW_UPDATENOW);
        end;
        temp.free;
end;

function TForm1.loadImage(img: Tbitmap): boolean;
var
        j: Tjpegimage;
begin
        if opendialog1.execute then
        begin
                j := Tjpegimage.create;
                j.LoadFromFile(opendialog1.filename);
                img.assign(j);
                j.free;
                result := true;
        end
        else
                result := false;
end;

procedure TForm1.LoadFirstselfClick(Sender: TObject);
begin
        if LoadImage(b) then
                FilterImage(b,checkbox1.checked, checkbox2.checked, checkbox3.checked , self);
end;

procedure TForm1.LoadSecondselfClick(Sender: TObject);
begin
        LoadImage(a);
end;

procedure TForm1.Exit1Click(Sender: TObject);
begin
        close;
end;

procedure TForm1.AlphaBlend1Click(Sender: TObject);
begin
        alpahblend(b,a,self,100);
        alpahblend(a,b,self,100);
end;

procedure TForm1.FadeIn1Click(Sender: TObject);
begin
        fade('in',b,self);
end;

procedure TForm1.FadeOut1Click(Sender: TObject);
begin
        fade('out',b,self);
end;

procedure TForm1.CheckBox1Click(Sender: TObject);
begin
        FilterImage(b,checkbox1.checked, checkbox2.checked, checkbox3.checked,self);
end;

procedure TForm1.filterImage(img: Tbitmap; red, green, blue : boolean; control : Tcontrol);
var
        p: Pbyte;
        i,j: cardinal;
        temp : Tbitmap;
        g: Tcontrolcanvas;
begin
        g := Tcontrolcanvas.create;
        temp := Tbitmap.create;
        temp.Assign(img);

        for i:= 0 to img.Height-1 do
        begin
                p  := temp.ScanLine[i];
                for j:=0 to img.width-1 do
                begin
                        if not red then
                                p^ := 0;
                        inc(p);
                        if not green then
                                p^ := 0;
                        inc(p);
                        if not blue then
                                p^ := 0;
                        inc(p);
                end;
        end;
        g.Control := control;
        g.draw(0,0,temp);
end;


procedure TForm1.Invert1Click(Sender: TObject);
begin
        invert(b,self);
end;

procedure TForm1.invert(img: TBitmap; control: Tcontrol);
var
        p: Pbyte;
        i,j: cardinal;
        temp : Tbitmap;
        g: Tcontrolcanvas;
begin
        g := Tcontrolcanvas.create;
        temp := Tbitmap.create;
        temp.Assign(img);

        for i:= 0 to img.Height-1 do
        begin
                p  := temp.ScanLine[i];
                for j:=0 to img.width-1 do
                begin
                        p^ := 255 - p^;
                        inc(p);
                        p^ := 255 - p^;
                        inc(p);
                        p^ := 255 - p^;
                        inc(p);
                end;
        end;
        g.Control := control;
        g.draw(0,0,temp);
        b.Assign(temp);
end;

procedure TForm1.RGBGBR1Click(Sender: TObject);
begin
        rgbimage(b,'GBR',self);
end;

procedure TForm1.RGBBRG1Click(Sender: TObject);
begin
        rgbimage(b,'BRG',self);
end;

procedure TForm1.RGBRBG1Click(Sender: TObject);
begin
        rgbimage(b,'RBG',self);
end;

procedure TForm1.RGBGRB1Click(Sender: TObject);
begin
        rgbimage(b,'GRB',self);
end;

procedure TForm1.RBGBGR1Click(Sender: TObject);
begin
        rgbimage(b,'BGR',self);
end;

procedure TForm1.rgbimage(img: TBitmap; convert: string;
  control: Tcontrol);
var
        p: Pbyte;
        r,g,b: byte;
        i,j: cardinal;
        temp : Tbitmap;
        can: Tcontrolcanvas;
begin
        can := Tcontrolcanvas.create;
        temp := Tbitmap.create;
        temp.Assign(img);

        for i:= 0 to img.Height-1 do
        begin
                p  := temp.ScanLine[i];
                for j:=0 to img.width-1 do
                begin
                        r := p^;
                        inc(p);
                        g := p^;
                        inc(p);
                        b := p^;
                        inc(p);
//GBR   BRG   RBG   GRB   BGR
                        if convert = 'GBR' then
                        begin
                                dec(p);
                                p^ := g;
                                dec(p);
                                p^ := b;
                                dec(p);
                                p^ := r;
                        end
                        else
                        if convert = 'BRG' then
                        begin
                                dec(p);
                                p^ := b;
                                dec(p);
                                p^ := r;
                                dec(p);
                                p^ := g;
                        end
                        else
                        if convert = 'RBG' then
                        begin
                                dec(p);
                                p^ := r;
                                dec(p);
                                p^ := b;
                                dec(p);
                                p^ := g;
                        end
                        else
                        if convert = 'GRB' then
                        begin
                                dec(p);
                                p^ := g;
                                dec(p);
                                p^ := r;
                                dec(p);
                                p^ := b;
                        end
                        else
                        if convert = 'BGR' then
                        begin
                                dec(p);
                                p^ := b;
                                dec(p);
                                p^ := r;
                                dec(p);
                                p^ := g;
                        end;
                        inc(p,3);
                end;
        end;
        can.Control := control;
        can.draw(0,0,temp);
end;

procedure TForm1.bright_contrast(img: TBitmap; value: integer;
  control: Tcontrol);
var
        p: Pbyte;
        i,j,k: cardinal;
        temp : Tbitmap;
        g: Tcontrolcanvas;
begin
        g := Tcontrolcanvas.create;
        temp := Tbitmap.create;
        temp.Assign(img);

        for i:= 0 to img.Height-1 do
        begin
                p  := temp.ScanLine[i];
                for j:=0 to img.width-1 do
                begin
                        for k:=1 to 3 do
                        begin
                                if (abs(value) + value)  > 0 then
                                begin
                                        if (p^ + value) < 255 then
                                                p^ := p^ + value
                                        else
                                                p^ := 255;
                                end
                                else
                                begin
                                        if (p^ + value) > 0 then
                                                p^ := p^ + value
                                        else
                                                p^ := 0;
                                end;
                                inc(p);
                        end;
                end;
        end;
        g.Control := control;
        g.draw(0,0,temp);
//        b.Assign(temp);
end;


procedure TForm1.BrightnessContrast1Click(Sender: TObject);
begin
        form2.show;
end;

procedure TForm1.TP1Click(Sender: TObject);
begin
        dither(b,self);
end;

procedure TForm1.dither(img: TBitmap; control: Tcontrol);
var
        p    : Pbyte;
        i,j  : cardinal;
        temp : Tbitmap;
        g    : Tcontrolcanvas;
        x,y,z : byte;
begin
        g := Tcontrolcanvas.create;
        temp := Tbitmap.create;
        temp.Assign(img);

        for i:= 0 to img.Height-1 do
        begin
                p  := temp.ScanLine[i];
                for j:=0 to (img.width div 2) -1  do
                begin
                        x := p^;
                        inc(p);
                        y := p^;
                        inc(p);
                        z := p^;
                        inc(p);

                        p^ := 0;
                        inc(p);
                        p^ := 0;
                        inc(p);
                        p^ := 0;
                        inc(p);
                end;
        end;
        g.Control := control;
        g.draw(0,0,temp);
//        b.Assign(temp);
end;

procedure TForm1.Grayscale1Click(Sender: TObject);
begin
        grayscale(b,self);
end;

procedure TForm1.grayscale(img: TBitmap; control: Tcontrol);
var
        p    : Pbyte;
        i,j  : cardinal;
        temp : Tbitmap;
        g    : Tcontrolcanvas;
        x,y,z: byte;
begin
        g := Tcontrolcanvas.create;
        temp := Tbitmap.create;
        temp.Assign(img);

        for i:= 0 to img.Height-1 do
        begin
                p  := temp.ScanLine[i];
                for j:=0 to img.width-1  do
                begin
                        x := p^;
                        inc(p);
                        y := p^;
                        inc(p);
                        z := p^;
                        inc(p);

                        x := (x+y+z) div 3;

                        dec(p);
                        p^ := x;
                        dec(p);
                        p^ := x;
                        dec(p);
                        p^ := x;

                        inc(p,3);
                end;
        end;
        g.Control := control;
        g.draw(0,0,temp);
        b.Assign(temp);
end;

procedure TForm1.tp(img: Tbitmap; control: Tcontrol);
var
        p    : Pbyte;
        i,j  : cardinal;
        temp : Tbitmap;
        g    : Tcontrolcanvas;
        x,y,z: byte;
begin
        g := Tcontrolcanvas.create;
        temp := Tbitmap.create;
        temp.Assign(img);
        randomize;

        for i:= 0 to img.Height-1 do
        begin
                p  := temp.ScanLine[i];
                for j:=0 to img.width-1  do
                begin
{                        if p^ > 1 then
                                p^ := p^ - 1;
                        inc(p);
                        if p^ > 1 then
                                p^ := p^ - 1;
                        inc(p);
                        if p^ > 1 then
                                p^ := p^ - 1;
                        inc(p);}

                        x := p^ ;
                        inc(p);
                        y := p^ ;
                        inc(p);
                        z := p^ ;
                        inc(p);

                        {x := x*y mod 255;}


                        dec(p);
                        p^ := x + y shr 2;
                        dec(p);
                        p^ := y + z shr 2;
                        dec(p);
                        p^ := z + x shr 2;

                        inc(p,3);
                end;
        end;
        g.Control := control;
        g.draw(0,0,temp);
        b.Assign(temp);
end;

procedure TForm1.TP2Click(Sender: TObject);
begin
        tp(b,self);
end;

end.
